=== cpp/dolfinx/la/CMakeLists.txt ===
set(HEADERS_la
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_la.h
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScKrylovSolver.h
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScMatrix.h
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScOperator.h
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScOptions.h
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScVector.h
  ${CMAKE_CURRENT_SOURCE_DIR}/SLEPcEigenSolver.h
  ${CMAKE_CURRENT_SOURCE_DIR}/SparsityPattern.h
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Vector.h
  ${CMAKE_CURRENT_SOURCE_DIR}/VectorSpaceBasis.h
  PARENT_SCOPE)

target_sources(dolfinx PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScKrylovSolver.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScMatrix.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScOperator.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScOptions.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/PETScVector.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/SLEPcEigenSolver.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/SparsityPattern.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/VectorSpaceBasis.cpp
)
