=== debian/changelog ===
dolfinx (2019.2.0~git20210130.c14cb0a-5) unstable; urgency=medium

  * use triple-slash (file:///) for mathjax local url replacement to
    make docs for demos properly legible.

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Jun 2021 14:59:59 +0200

dolfinx (2019.2.0~git20210130.c14cb0a-4) unstable; urgency=medium

  * update fenics:Upstream-Version to 2019.2.0~git20210116 to ensure
    up-to-date python3-ffcx (using basix) is installed.

 -- Drew Parsons <dparsons@debian.org>  Sat, 13 Feb 2021 02:28:09 +0100

dolfinx (2019.2.0~git20210130.c14cb0a-3) unstable; urgency=medium

  * tighten Build-Depends: python3-ffcx (>= 2019.2.0~git20210122.22ca4c0~)

 -- Drew Parsons <dparsons@debian.org>  Thu, 11 Feb 2021 22:37:37 +0100

dolfinx (2019.2.0~git20210130.c14cb0a-2) unstable; urgency=medium

  * bring latest snapshot to unstable

 -- Drew Parsons <dparsons@debian.org>  Thu, 11 Feb 2021 12:43:27 +0100

dolfinx (2019.2.0~git20210130.c14cb0a-1) experimental; urgency=medium

  * New upstream snapshot.
    - Build-Depends: libbasix-dev, python3-basix
    - applies debian patch lowercase_slepc.pc_PR1195.patch 
  * debian patch find_basix.patch looks for libbasix.so in
    standard multiarch library path (used by libbasix-dev)
  * override dh_auto_clean to clean generated files in source dirs

 -- Drew Parsons <dparsons@debian.org>  Sun, 31 Jan 2021 16:24:28 +0100

dolfinx (2019.2.0~git20201109.17bda9f-6) unstable; urgency=medium

  * debian patch cmake_libdir_PR1359.patch applies upstream PR#1350
    which install dolfinx cmake files under libdir not /usr/share
    - this upstream patch places dolfinx cmake files in
      /usr/lib/<arch>/cmake/dolfinx. But Debian moves them back to
      /usr/share/dolfinx/cmake in libdolfinx-dev and edits them in
      order to keep libdolfinx-dev arch-independent.
  * debian patch FindPETSc_mpi_include_path.patch ensures MPI header
    files are always used (if available) when testing PETSc.
  * skip gmsh tests and demos in debian/tests. Currently triggers
    SIGABRT in libgmsh.so.4 or in eigen3. See Bug#981128.

 -- Drew Parsons <dparsons@debian.org>  Wed, 27 Jan 2021 17:18:53 +0100
